# -*- coding: utf_8 -*-
# 表名: hstgrp
# 作者: 陈磊
# 时间: 2019-11-04


from sqlalchemy.ext.declarative import declarative_base
from sqlalchemy import Column, Integer, VARCHAR, BIGINT, SMALLINT, DATETIME, DECIMAL, BigInteger, FLOAT, NUMERIC, TEXT
from sqlalchemy.orm.exc import MultipleResultsFound, NoResultFound
from sqlalchemy import or_

from WorkUtils.UtilsLog import UtilsLog
from WorkUtils.UtilsDataBase import UtilsDataBase

import time

Base = declarative_base()


class HstGrp(Base):
    """
    主机组信息表
    """
    __tablename__ = "hstgrp"

    groupid = Column(BigInteger, primary_key=True)
    name = Column(VARCHAR(255))
    internal = Column(Integer)
    flags = Column(Integer)


class DataHstGrp(object):
    def __init__(self):
        self.log = UtilsLog()
        self.log.info(self.__class__)

        self.table = HstGrp

    def select_all_from_allKeys(self, session, groupid=None, name=None, internal=None, flags=None):
        """
        :param session: 指针
        :param groupid:
        :param name:
        :param internal:
        :param flags:
        :return: 查询结果
        """
        self.log.debug("查询数据库:")
        try:
            base = UtilsDataBase()
            base.add_param(_key="groupid", value=groupid)
            base.add_param(_key="name", value=name)
            base.add_param(_key="internal", value=internal)
            base.add_param(_key="flags", value=flags)
            sql_rep = session.query(self.table).filter_by(**base.param).all()
            self.log.debug(sql_rep)
            session.close()
            return sql_rep
        except UtilsDataBase().errors as error:
            self.log.error("异常:")
            self.log.error(error)
            session.close()
            return error

    def delete_like_name(self, session, name):
        """
        :param session: 指针
        :param name:
        :return:
        """
        self.log.debug("查询数据库:")
        try:
            self.log.debug("删除相关测试数据")
            session.query(self.table).filter(self.table.name.like(str(name) + "%")).delete(synchronize_session=False)
            # session.delete(sql)
            session.commit()
            session.close()
            self.log.debug("删除成功")
            return True
        except UtilsDataBase().errors as error:
            self.log.error("异常:")
            self.log.error(error)
            session.close()
            return error
